<!DOCTYPE html>
<html lang="en">

<head>
	<title>album CRUD</title>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width, initial-scale=1">
	<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">

	<link rel="stylesheet" href="mystyle.css">
	<script src="https://cdnjs.cloudflare.com/ajax/libs/moment.js/2.24.0/moment.min.js"></script>
	<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>

	<script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
	<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css" />


	<!-- Import Datatable sau jquery -->
	<!-- Import them style bootstrap cho datatable -->
	<link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
	<script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
	<script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>

</head>

<body>

	<div class="container">
		<h2 style="text-align: center;">Quản trị Album</h2>

		<!-- Create voucher modal -->
		<div>
			<div id="create-album-modal" class="modal fade" tabindex="-1">
				<div class="modal-dialog">
					<div class="modal-content">
						<div class="modal-header">
							<h5 class="modal-title" id="h5-modal-title">Create new Album</h5>
							<button class="close" data-dismiss="modal">&times;</button>
						</div>
						<div class="modal-body">
							<form>
								<div class="row form-group">
									<div class="col-sm-3">
										<label>Mã album</label>
									</div>
									<div class="col-sm-9">
										<input type="text" id="input-album-code" class="form-control">
									</div>
								</div>
								<div class="row form-group">
									<div class="col-sm-3">
										<label>Tên album</label>
									</div>
									<div class="col-sm-9">
										<input type="text" id="input-album-name" class="form-control">
									</div>
								</div>
								<div class="row form-group">
									<div class="col-sm-3">
										<label>Mô tả</label>
									</div>
									<div class="col-sm-9">
										<input type="text" id="input-description" name="note" class="form-control">
									</div>
								</div>

							</form>
						</div>
						<div class="modal-footer">
							<button class="btn btn-secondary" id="btn-create-cancel"
								data-dismiss="modal">Cancel</button>
							<button class="btn btn-primary" id="btn-create-album">Create Album</button>
						</div>
					</div>
				</div>
			</div>
		</div>

		<!-- Update voucher modal -->
		<div>
			<div id="update-album-modal" class="modal fade" tabindex="-1">
				<div class="modal-dialog">
					<div class="modal-content">
						<div class="modal-header">
							<h5 class="modal-title" id="h5-modal-title">Update Album</h5>
							<button class="close" data-dismiss="modal">&times;</button>
						</div>
						<div class="modal-body">
							<form>
								<div class="row form-group">
									<div class="col-sm-3">
										<label>Mã album</label>
									</div>
									<div class="col-sm-9">
										<input type="text" id="input-album-code-update" class="form-control">
									</div>
								</div>
								<div class="row form-group">
									<div class="col-sm-3">
										<label>Tên album</label>
									</div>
									<div class="col-sm-9">
										<input type="text" id="input-album-name-update" class="form-control">
									</div>
								</div>
								<div class="row form-group">
									<div class="col-sm-3">
										<label>Mô tả</label>
									</div>
									<div class="col-sm-9">
										<input type="text" id="input-description-update" name="note"
											class="form-control">
									</div>
								</div>

							</form>
						</div>
						<div class="modal-footer">
							<button class="btn btn-secondary" id="btn-create-cancel"
								data-dismiss="modal">Cancel</button>
							<button class="btn btn-primary" id="btn-update-album">Update Album</button>
						</div>
					</div>
				</div>
			</div>
		</div>

		<!-- Delete confirm modal -->
		<div>
			<div class="modal fade" tabindex="-1" id="delete-modal">
				<div class="modal-dialog">
					<div class="modal-content">
						<div class="modal-header">
							<h5 class="modal-title" id="h5-modal-title">Album Delete Confirmation</h5>
							<button class="close" data-dismiss="modal">&times;</button>
						</div>
						<div class="modal-body">
							<label>Bạn có chắc chắn muốn xóa album này không?</label>
						</div>
						<div class="modal-footer">
							<button class="btn btn-danger" id="btn-confirm-delete-album">Confirm</button>
							<button class="btn btn-secondary" data-dismiss="modal">Cancel</button>
						</div>
					</div>
				</div>
			</div>
		</div>
		<button class="btn btn-success " id="create-album">Add Album</button>
		<table class="table table-bordered table-striped table-hover" id="album-table">
			<thead>
				<tr>
					<th>STT</th>
					<th>Mã Album</th>
					<th>Tên Album</th>
					<th>Mô tả</th>
					<th>Ngày tạo</th>
					<th>Action</th>
				</tr>
		</table>
	</div>
	<script>
		/*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
		// Biến mảng hằng số chứa danh sách tên các thuộc tính
		const gALBUM_COLS = ["id", "albumCode", "albumName", "description", "created", "action"];

		// Biến mảng toàn cục định nghĩa chỉ số các cột tương ứng
		const gALBUM_STT_COL = 0;
		const gALBUM_CODE_COL = 1;
		const gALBUM_NAME_COL = 2;
		const gALBUM_DESCRIPTION_COL = 3;
		const gALBUM_CREATED_COL = 4;
		const gALBUM_ACTION_COL = 5;
		var table = $("#album-table").DataTable({
			columns: [
				{ data: gALBUM_COLS[gALBUM_STT_COL] },
				{ data: gALBUM_COLS[gALBUM_CODE_COL] },
				{ data: gALBUM_COLS[gALBUM_NAME_COL] },
				{ data: gALBUM_COLS[gALBUM_DESCRIPTION_COL] },
				{ data: gALBUM_COLS[gALBUM_CREATED_COL] },
				{ data: gALBUM_COLS[gALBUM_ACTION_COL] }
			],
			columnDefs: [
				{ // định nghĩa lại cột action
					targets: gALBUM_ACTION_COL,
					defaultContent: `
					<i class="fas fa-edit edit-album"></i>
					<i class="fas fa-trash-alt delete-album"></i>
			  
			`
				}
			]
		})
		var gRowSelected = ''
		var glistAlbum = [];
		var galbumIdSelected = '';
		var gRowAlbumSelected = '';
		var glistAlbumValidateUpdate = [];
		/*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
		$(document).ready(function () {
			onPageLoading();
			//create new album
			$('#create-album').on('click', function () {

				onBtnAddAlbumClick();
			})
			$('#btn-create-album').on('click', function () {

				onBtnCreateAlbumOnModalClick();
			})
			//edit album
			$('#album-table').on('click', '.edit-album', function () {

				onBtnEditAlbumClick(this);
			})
			$('#btn-update-album').on('click', function () {
				onBtnUpdateOnModalClick()
			})

			//xóa album
			$('#album-table').on('click', '.delete-album', function () {

				onBtnDeleteAlbumClick(this);
			})
			$('#btn-confirm-delete-album').on('click', function () {

				onBtnConfirmOnDeleteModalClick(this);
			})




		})
		/*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
		//hàm gọi api load danh sách album từ server khi tải trang
		function onPageLoading() {

			$.ajax({
				url: "http://localhost:8080/albums/all",
				type: "GET",
				dataType: "json",
				success: function (res) {
					glistAlbum = res
					console.log('check data get all album from server', res);
					table.clear();
					table.rows.add(res);
					table.draw();
				},
				error: function (err) {
					console.log(err.response);
				}
			})
		}
		//hàm thực hiện khi nhấn nút add new album
		function onBtnAddAlbumClick() {

			$("#create-album-modal").modal("show");

		}
		//hàm thực hiện khi nhấn create album trên modal
		function onBtnCreateAlbumOnModalClick() {
			createNewAlbum();
			$("#create-album-modal").modal("hide");
		}
		//hàm thực hiện khi lúc nút edit
		function onBtnEditAlbumClick(paramButton) {
			$("#update-album-modal").modal("show");
			galbumIdSelected = getAlbumIdFromButton(paramButton)

			console.log('check id album selected', galbumIdSelected)
			callApiToGetAlbumById(galbumIdSelected)
		}
		//hàm thực hiện khi nhấn nút update trên modal
		function onBtnUpdateOnModalClick() {
			updateAlbum(galbumIdSelected);
			$("#update-album-modal").modal("hide");

		}
		//Hàm thực hiện khi nhấn nút delete
		function onBtnDeleteAlbumClick(paramButton) {
			$("#delete-modal").modal("show");
			galbumIdSelected = getAlbumIdFromButton(paramButton)

		}
		//hàm thực hiện khi nhấn nút confirm trên delete modal
		function onBtnConfirmOnDeleteModalClick() {
			deletedAlbum();
			$("#delete-modal").modal("hide");

		}
		/*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
		//hàm trả ra id album khi nhấn nút edit
		function getAlbumIdFromButton(paramButton) {
			var vTableRow = $(paramButton).parents("tr");
			gRowAlbumSelected = table.row(vTableRow).data();
			console.log(gRowAlbumSelected.id);
			return gRowAlbumSelected.id;
		}
		//hàm gọi api để lấy album cần edit theo id
		function callApiToGetAlbumById(id) {

			$.ajax({
				url: `http://localhost:8080/albums/detail_by_id/${id}`,
				async: false,
				type: "GET",
				dataType: "json",
				success: function (res) {
					console.log('check data album need to update ress', res);
					if (glistAlbum && glistAlbum.length > 0) {
						glistAlbum.map((item, index) => {
							if (item.id == res.id) {
								glistAlbum.splice(index, 1)
							}
						})
					}
					showDataUpdateOnForm(res);
				},
				error: function (err) {
					console.log(err.response);
				}
			})

		}
		//hàm hiển thị data lên form edit
		function showDataUpdateOnForm(paramAlbum) {
			$('#input-album-code-update').val(paramAlbum.albumCode);
			$('#input-album-name-update').val(paramAlbum.albumName);
			$('#input-description-update').val(paramAlbum.description);

		}

		function updateAlbum(paramAlbumId) {
			let objData = {
				albumCode: '',
				albumName: '',
				description: '',
			}
			let objDataFromForm = getDataOnFormUpdate(objData);
			var vCheck = validateDataOnform(objDataFromForm);
			if (vCheck) {
				let albumExist = '';
				if (glistAlbum && glistAlbum.length > 0) {

					for (let i = 0; i < glistAlbum.length; i++) {
						if (glistAlbum[i].albumCode == objDataFromForm.albumCode) {
							alert("Album existed");
							albumExist = glistAlbum[i];
							console.log('Album existed', albumExist)
						}
					}

				}
				if (albumExist == '') {

					callApiToUpdateData(paramAlbumId, objDataFromForm);
					onPageLoading();
				}



			}
		}




		//hàm thu thập dư liệu trên form update
		function getDataOnFormUpdate(obj) {
			obj.albumCode = $('#input-album-code-update').val();
			obj.albumName = $('#input-album-name-update').val();
			obj.description = $('#input-description-update').val();
			return obj
		}
		//hàm gọi api để update album
		function callApiToUpdateData(id, paramOrderObject) {
			$.ajax({
				async: false,
				url: `http://localhost:8080/album/update/${id}`,
				type: 'PUT',
				async: false,
				contentType: "application/json;charset=UTF-8",
				data: JSON.stringify(paramOrderObject),
				success: function (res) {
					console.log('check data update response', res);

				},
				error: function (error) {
					console.assert(error.responseText)
				}
			})
		}

		//save new album
		function createNewAlbum() {
			let objData = {
				albumCode: '',
				albumName: '',
				description: '',
			}
			let objDataFromForm = getDataOnForm(objData);
			var vCheck = validateDataOnform(objDataFromForm);
			if (vCheck) {
				if (glistAlbum && glistAlbum.length > 0) {
					glistAlbum.map(item => {
						if (item.albumCode == objDataFromForm.albumCode) {
							alert("Album existed")
						} else {
							console.log('check data post', objDataFromForm)
							callApiToPostData(objDataFromForm);
							onPageLoading();

						}
					})
				}

			}

		}
		//hàm thực hiện validate dữ liệu trên form
		function validateDataOnform(paramObjData) {
			if (!paramObjData.albumCode) {
				alert('Missing album code')
				return false;
			}
			if (!paramObjData.albumName) {
				alert('Missing album name')
				return false;
			}
			if (!paramObjData.description) {
				alert('Missing description')
				return false;
			}
			return true;


		}
		//hàm thu thập dư liệu trên form
		function getDataOnForm(obj) {
			obj.albumCode = $('#input-album-code').val();
			obj.albumName = $('#input-album-name').val();
			obj.description = $('#input-description').val();
			return obj
		}
		//hàm gọi api để tạo album mới
		function callApiToPostData(paramOrderObject) {
			$.ajax({
				async: false,
				url: `http://localhost:8080/albums`,
				type: 'POST',
				async: false,
				contentType: "application/json;charset=UTF-8",
				data: JSON.stringify(paramOrderObject),
				success: function (res) {

					console.log('check data post response', res);

				},
				error: function (error) {
					console.assert(error.responseText)
				}
			})
		}
		function deletedAlbum() {
			callApiToDeleteData(galbumIdSelected);
			onPageLoading();
		}
		function callApiToDeleteData(id) {
			$.ajax({
				async: false,
				url: `http://localhost:8080/album/delete/${id}`,
				type: 'DELETE',
				async: false,
				// contentType: "application/json;charset=UTF-8",
				// data: JSON.stringify(paramOrderObject),
				success: function (res) {
					alert('Delete success')

				},
				error: function (error) {
					console.assert(error.responseText)
				}
			})
		}


	</script>
</body>

</html>